# LC.L
# The LC compiler, Version 0.03

main mainprogram    # name of entry procedure

# numbers

declare ii          # temporary variables
declare ii1

declare minusone
declare minvalue
declare hexdigit 16

# control codes

declare tab
declare cr
declare lf

# digit char

declare zerochar
declare ninechar

# punctuation

declare space
declare bang
declare quote
declare sharp
declare dollar
declare and
declare lparen
declare rparen
declare star
declare plus
declare comma
declare minus
declare dot
declare slash
declare colon
declare semicolon
declare less
declare equal
declare greater
declare query
declare atsign
declare lbracket
declare rbracket
declare hat
declare underscore
declare or
declare squiggle

# lower case

declare lettera
declare letterb
declare letterc
declare letterd
declare lettere
declare letterf
declare letterg
declare letterh
declare letteri
declare letterj
declare letterk
declare letterl
declare letterm
declare lettern
declare lettero
declare letterp
declare letterq
declare letterr
declare letters
declare lettert
declare letteru
declare letterv
declare letterw
declare letterx
declare lettery
declare letterz

# tokens
declare tbad
declare teof
declare tmain
declare tprocedure
declare tend
declare tdeclare
declare tcall
declare tgoto
declare tif
declare tthen
declare telse
declare telseif
declare twhile
declare tifgoto
declare tlabel
declare treturn
declare tload
declare tstore
declare tadd
declare tsubtract
declare tmultiply
declare tdivide
declare tand
declare tor
declare tless
declare tlessequal
declare tequal
declare tnotequal
declare tgreater
declare tgreaterequal
declare tlbracket
declare trbracket
declare tidentifier
declare tnumber
declare tsemicolon

# 386 registers
declare eax
declare ecx
declare edx
declare ebx
declare esp
declare ebp
declare esi
declare edi

procedure initconstants
  # numbers
  $ 0 - 1 -> minusone
  $ 65536 * 32768 -> minvalue   # HACK: no exceptions raised on overflow
  $  0 -> ii $  48 -> hexdigit[ii]
  $  1 -> ii $  49 -> hexdigit[ii]
  $  2 -> ii $  50 -> hexdigit[ii]
  $  3 -> ii $  51 -> hexdigit[ii]
  $  4 -> ii $  52 -> hexdigit[ii]
  $  5 -> ii $  53 -> hexdigit[ii]
  $  6 -> ii $  54 -> hexdigit[ii]
  $  7 -> ii $  55 -> hexdigit[ii]
  $  8 -> ii $  56 -> hexdigit[ii]
  $  9 -> ii $  57 -> hexdigit[ii]
  $ 10 -> ii $  97 -> hexdigit[ii]
  $ 11 -> ii $  98 -> hexdigit[ii]
  $ 12 -> ii $  99 -> hexdigit[ii]
  $ 13 -> ii $ 100 -> hexdigit[ii]
  $ 14 -> ii $ 101 -> hexdigit[ii]
  $ 15 -> ii $ 102 -> hexdigit[ii]

  # control codes
  $   9 -> tab
  $  13 -> cr
  $  10 -> lf

  # digit character base
  $  48 -> zerochar
  $  57 -> ninechar

  # letters
  $  97 -> lettera
  $  98 -> letterb
  $  99 -> letterc
  $ 100 -> letterd
  $ 101 -> lettere
  $ 102 -> letterf
  $ 103 -> letterg
  $ 104 -> letterh
  $ 105 -> letteri
  $ 106 -> letterj
  $ 107 -> letterk
  $ 108 -> letterl
  $ 109 -> letterm
  $ 110 -> lettern
  $ 111 -> lettero
  $ 112 -> letterp
  $ 113 -> letterq
  $ 114 -> letterr
  $ 115 -> letters
  $ 116 -> lettert
  $ 117 -> letteru
  $ 118 -> letterv
  $ 119 -> letterw
  $ 120 -> letterx
  $ 121 -> lettery
  $ 122 -> letterz

  # punctuation
  $  32 -> space
  $  33 -> bang
  $  34 -> quote
  $  35 -> sharp
  $  36 -> dollar
  $  38 -> and
  $  40 -> lparen
  $  41 -> rparen
  $  42 -> star
  $  43 -> plus
  $  44 -> comma
  $  45 -> minus
  $  46 -> dot
  $  47 -> slash
  $  58 -> colon
  $  59 -> semicolon
  $  60 -> less
  $  61 -> equal
  $  62 -> greater
  $  63 -> query
  $  64 -> atsign
  $  91 -> lbracket
  $  93 -> rbracket
  $  94 -> hat
  $  95 -> underscore
  $ 124 -> or
  $ 126 -> squiggle

  # tokens
  $ 0 -> tbad
  $ 1 -> teof
  $ 2 -> tdeclare
  $ 3 -> tcall
  $ 4 -> tgoto
  $ 5 -> tifgoto
  $ 6 -> tlabel
  $ 7 -> treturn
  $ 8 -> tload
  $ 9 -> tstore
  $ 10 -> tadd
  $ 11 -> tsubtract
  $ 12 -> tmultiply
  $ 13 -> tdivide
  $ 14 -> tand
  $ 15 -> tor
  $ 16 -> tless
  $ 17 -> tequal
  $ 18 -> tgreater
  $ 19 -> tlbracket
  $ 20 -> trbracket
  $ 21 -> tidentifier
  $ 22 -> tnumber
  $ 23 -> tlessequal
  $ 24 -> tnotequal
  $ 25 -> tgreaterequal
  $ 26 -> tprocedure
  $ 27 -> tend
  $ 28 -> tmain
  $ 29 -> tif
  $ 30 -> tthen
  $ 31 -> telse
  $ 32 -> telseif
  $ 33 -> twhile
  $ 34 -> tsemicolon

  # registers
  $ 0 -> eax
  $ 1 -> ecx
  $ 2 -> edx
  $ 3 -> ebx
  $ 4 -> esp
  $ 5 -> ebp
  $ 6 -> esi
  $ 7 -> edi
end

# variables

declare argchar
declare temp   # single subroutine level, or return value
declare i      # high level loop variable
declare j      # high level loop variable
declare k      # low level loop variable
declare n      # subroutine argument

# lexical analyzer
declare nxtchar
declare nxttoken

declare idlength
declare idlengthmax     # capacity in number of characters
declare idstring 256

declare nxttokval       # value associated with token
                        # number token -> value of number
                        # identifier   -> symbol table index

# symbol table
declare nameindex       # temporary for searching symbol table
declare eqindex         # temporary for comparing name strings

declare numsym          # number of symbols stored
declare numsymmax       # capacity in number of entries
declare symname  500
declare symvalue 500

declare namepoolsize    # number of bytes stored
declare namepoolmax     # capacity in number of bytes
declare namepool 8192

# code generation
declare csize
declare dsize
declare binval

# number conversion
declare minusflag
# -- unpacked digit arrays
declare decarray 11    # digits from least sig to most sig + sign (1 = negative)
declare hexarray  8    # digits from least sig to most sig

# error handling
declare errorflag

# files
declare fnamelengthmax  # capacity in number of characters
declare srcfname 260
declare incfname 260
declare tgtfname 260
declare lstfname 260

declare srcfile
declare tgtfile
declare lstfile
declare prebinfile # temporary bin file
declare tblfile    # forward reference table file
declare binfile    # COFF object file

declare tgtbyte
declare lstchar

procedure mainprogram
  call initconstants

  # set limit parameters
  $ 255 -> idlengthmax
  $ 500 -> numsymmax
  $ 8192 -> namepoolmax
  $ 259 -> fnamelengthmax

  $ 0 -> errorflag

  call parsecommandline

  # let's try to open a list file first
  # if it can be opened, we can send error messages to it

  # list file name
  $ 0 -> i
: copylfn
  $ lstfname[i] -> temp
  $ temp -> sysarray[i]
  $ i + 1 -> i
  $ temp > 0 ? copylfn

  # open for write
  $ 1 -> sysarg1
  $ 2 -> sysfn
  call system
  $ sysarg1 -> lstfile

  $ lstfile <> minusone ? listfileok
  $ 2 -> errorflag  # all we can do is return an error code to the system
  goto exitprogram
: listfileok

  # now let's open the other files

  # source file name
  $ 0 -> i
: copysfn
  $ srcfname[i] -> temp
  $ temp -> sysarray[i]
  $ i + 1 -> i
  $ temp > 0 ? copysfn

  # open for read
  $ 0 -> sysarg1
  $ 2 -> sysfn
  call system
  $ sysarg1 -> srcfile
  $ srcfile = minusone ? fileerror

  # target file name
  $ 0 -> i
: copytfn
  $ tgtfname[i] -> temp
  $ temp -> sysarray[i]
  $ i + 1 -> i
  $ temp > 0 ? copytfn

  # open for write
  $ 1 -> sysarg1
  $ 2 -> sysfn
  call system
  $ sysarg1 -> binfile
  $ binfile = minusone ? fileerror

  # temporary bin file
  $ 0 -> ii $ dollar -> sysarray[ii]
  $ 1 -> ii $ dollar -> sysarray[ii]
  $ 2 -> ii $ zerochar + 1 -> sysarray[ii]
  $ 3 -> ii $ 0 -> sysarray[ii]

  # open for write
  $ 1 -> sysarg1
  $ 2 -> sysfn
  call system
  $ sysarg1 -> prebinfile
  $ prebinfile = minusone ? fileerror

  # forward reference table file
  $ 0 -> ii $ dollar -> sysarray[ii]
  $ 1 -> ii $ dollar -> sysarray[ii]
  $ 2 -> ii $ zerochar + 2 -> sysarray[ii]
  $ 3 -> ii $ 0 -> sysarray[ii]

  # open for write
  $ 1 -> sysarg1
  $ 2 -> sysfn
  call system
  $ sysarg1 -> tblfile
  $ tblfile = minusone ? fileerror

  # ASM file
  $ 0 -> ii $ lettera -> sysarray[ii]
  $ 1 -> ii $ dot     -> sysarray[ii]
  $ 2 -> ii $ lettera -> sysarray[ii]
  $ 3 -> ii $ letters -> sysarray[ii]
  $ 4 -> ii $ letterm -> sysarray[ii]
  $ 5 -> ii $ 0 -> sysarray[ii]

  # open for write
  $ 1 -> sysarg1
  $ 2 -> sysfn
  call system
  $ sysarg1 -> tgtfile
  $ tgtfile = minusone ? fileerror

  call parse

  # close intermediate files
  $ prebinfile -> sysarg1
  $ 3 -> sysfn
  call system
  $ tblfile -> sysarg1
  $ 3 -> sysfn
  call system

  # temporary bin file
  $ 0 -> ii $ dollar -> sysarray[ii]
  $ 1 -> ii $ dollar -> sysarray[ii]
  $ 2 -> ii $ zerochar + 1 -> sysarray[ii]
  $ 3 -> ii $ 0 -> sysarray[ii]
  # reopen for read
  $ 0 -> sysarg1
  $ 2 -> sysfn
  call system
  $ sysarg1 -> prebinfile
  $ prebinfile = minusone ? fileerror

  # forward reference table file
  $ 0 -> ii $ dollar -> sysarray[ii]
  $ 1 -> ii $ dollar -> sysarray[ii]
  $ 2 -> ii $ zerochar + 2 -> sysarray[ii]
  $ 3 -> ii $ 0 -> sysarray[ii]
  # reopen for read
  $ 0 -> sysarg1
  $ 2 -> sysfn
  call system
  $ sysarg1 -> tblfile
  $ tblfile = minusone ? fileerror

  call finishbin
  call writesummary

  # close files

  $ srcfile -> sysarg1
  $ 3 -> sysfn
  call system

  $ tgtfile -> sysarg1
  $ 3 -> sysfn
  call system

  $ lstfile -> sysarg1
  $ 3 -> sysfn
  call system

  $ prebinfile -> sysarg1
  $ 3 -> sysfn
  call system

  $ tblfile -> sysarg1
  $ 3 -> sysfn
  call system

  $ binfile -> sysarg1
  $ 3 -> sysfn
  call system

  goto exitprogram

: fileerror
  $ 2 -> errorflag

  $ star    -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  $ letterf -> lstchar ; call writechar
  $ letteri -> lstchar ; call writechar
  $ letterl -> lstchar ; call writechar
  $ lettere -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ lettere -> lstchar ; call writechar
  $ letterr -> lstchar ; call writechar
  $ letterr -> lstchar ; call writechar
  $ lettero -> lstchar ; call writechar
  $ letterr -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  call writecrlf

: exitprogram
  # exit
  $ errorflag -> sysarg1
  $ 0 -> sysfn
  call system
end

# ===== the main parser

procedure parse
  # initialize symbol table
  $ 0 -> numsym
  $ 0 -> symname[numsym]
  $ 0 -> namepoolsize
  $ 0 -> namepool[namepoolsize]

  # initialize code generator
  $ 0 -> csize
  $ 0 -> dsize
  call emitheader

  # initialize lexical analyzer
  call getchar
  call gettoken

  $ nxttoken <> tmain ? skipmain
  call parsemain
: skipmain

: mainloop
  $ nxttoken = teof ? exitmainloop

  call parseinstruction

  goto mainloop
: exitmainloop
  call emittrailer
end

# ===== parse main declaration =====
# 'main' detected, expect id, create jump to main procedure

procedure parsemain
  call gettoken
  $ nxttoken = tidentifier ? mainok
  call error
  return
: mainok
  # E9 displ
  $ 233 -> n ; call emitdb
  $ semicolon -> tgtbyte ; call outbyte
  $ letterj -> tgtbyte ; call outbyte
  $ letterm -> tgtbyte ; call outbyte
  $ letterp -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ nxttokval -> n ; call emitid
  call outcrlf
  $ nxttokval -> n ; call emitlabeldisp
  call outcrlf

  call gettoken
end

# ===== parse instruction =====

procedure parseinstruction
  $ nxttoken = tprocedure ? parseprocedure
  $ nxttoken = tend ? parseend
  $ nxttoken = tdeclare ? parsedclvar
  $ nxttoken = tcall ? parsecall
  $ nxttoken = tgoto ? parsegoto
  $ nxttoken = tifgoto ? parseifgoto
  $ nxttoken = tlabel ? parselabel
  $ nxttoken = treturn ? parsereturn
  $ nxttoken = tload ? parseload
  $ nxttoken = tstore ? parsestore
  $ nxttoken = tadd ? parseadd
  $ nxttoken = tsubtract ? parsesub
  $ nxttoken = tmultiply ? parsemult
  $ nxttoken = tdivide ? parsediv
  $ nxttoken = tand ? parseand
  $ nxttoken = tor ? parseor
  $ nxttoken = tless ? parselt
  $ nxttoken = tlessequal ? parsele
  $ nxttoken = tequal ? parseeq
  $ nxttoken = tnotequal ? parsene
  $ nxttoken = tgreater ? parsegt
  $ nxttoken = tgreaterequal ? parsege
  $ nxttoken = tidentifier ? parseid
  $ nxttoken = tnumber ? parsenum
  $ nxttoken = tsemicolon ? parsesemicolon

  call error
  $ squiggle -> tgtbyte ; call outbyte
  call gettoken
  return

: parseid
  call error
  $ nxttokval -> n ; call emitid
  call gettoken
  return

: parsenum
  call error
  $ nxttokval -> n ; call emitdec
  call gettoken
  return

  # =====
  # ';' detected, ignore
  # =====
: parsesemicolon
  call gettoken
  return

  # =====
  # 'procedure' detected, find name, generate label
  # =====
: parseprocedure
  call gettoken
  $ nxttoken = tidentifier ? procedureok
  call error
  return
: procedureok
  $ csize -> symvalue[nxttokval]
  $ nxttokval -> n ; call emitid
  $ colon -> tgtbyte ; call outbyte
  call outcrlf

  call gettoken
  return

  # =====
  # 'end' detected, generate instruction
  # =====
: parseend
  # B9 00000000
  $ 184 + ecx -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitmov
  $ space -> tgtbyte ; call outbyte
  call emitecx
  $ comma -> tgtbyte ; call outbyte
  $ 0 -> n ; call emitdec
  call outcrlf
  $ 0 -> n ; call emitdd
  call outcrlf

  # 8B C1
  $ 139 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitmov
  $ space -> tgtbyte ; call outbyte
  call emiteax
  $ comma -> tgtbyte ; call outbyte
  call emitecx
  call outcrlf
  $ 8 * eax + ecx + 192 -> n ; call emitdb
  call outcrlf

  # C3
  $ 195 -> n ; call emitdb
  $ semicolon -> tgtbyte ; call outbyte
  call emitreturn
  call outcrlf
  call gettoken
  return

  # =====
  # declare detected, find name, generate declaration
  # =====
: parsedclvar
  call gettoken
  $ nxttoken = tidentifier ? dclvarok
  call error
  return
: dclvarok
  $ symvalue[nxttokval] = minusone ? notyetdeclared
  call error
: notyetdeclared
  $ dsize -> symvalue[nxttokval]

  call gettoken
  $ nxttoken = tnumber ? dclarraywithdim

: dclvar1
  $ dsize + 4 -> dsize
  return

: dclarraywithdim
  $ 4 * nxttokval -> temp
  $ dsize + temp -> dsize

  call gettoken
  return

  # =====
  # call detected, find name, generate instruction
  # =====
: parsecall
  call gettoken
  $ nxttoken = tidentifier ? callok
  call error
  return
: callok
  # E8 displ
  $ 232 -> n ; call emitdb
  $ semicolon -> tgtbyte ; call outbyte
  $ letterc -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
  $ letterl -> tgtbyte ; call outbyte
  $ letterl -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ nxttokval -> n ; call emitid
  call outcrlf
  $ nxttokval -> n ; call emitlabeldisp
  call outcrlf

  call gettoken
  return

  # =====
  # goto detected, find name, generate instruction
  # =====
: parsegoto
  call gettoken
  $ nxttoken = tidentifier ? gotook
  call error
  return
: gotook
  # E9 displ
  $ 233 -> n ; call emitdb
  $ semicolon -> tgtbyte ; call outbyte
  $ letterj -> tgtbyte ; call outbyte
  $ letterm -> tgtbyte ; call outbyte
  $ letterp -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ nxttokval -> n ; call emitid
  call outcrlf
  $ nxttokval -> n ; call emitlabeldisp
  call outcrlf

  call gettoken
  return

  # =====
  # ? detected, find name, generate instructions
  # =====
: parseifgoto
  call gettoken
  $ nxttoken = tidentifier ? ifgotook
  call error
  return
: ifgotook
  # 85 C0
  $ 133 -> n ; call emitdb
  $ semicolon -> tgtbyte ; call outbyte
  $ lettert -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ letters -> tgtbyte ; call outbyte
  $ lettert -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  call emiteax
  $ comma   -> tgtbyte ; call outbyte
  call emiteax
  call outcrlf
  $ 8 * eax + eax + 192 -> n ; call emitdb
  call outcrlf

  # 0F 85 displ
  $ 15 -> n ; call emitdb
  $ semicolon -> tgtbyte ; call outbyte
  $ letterj -> tgtbyte ; call outbyte
  $ lettern -> tgtbyte ; call outbyte
  $ letterz -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ nxttokval -> n ; call emitid
  call outcrlf
  $ 133 -> n ; call emitdb
  call outcrlf
  $ nxttokval -> n ; call emitlabeldisp
  call outcrlf

  call gettoken
  return

  # =====
  # : detected, find name, generate label
  # =====
: parselabel
  call gettoken
  $ nxttoken = tidentifier ? labelok
  call error
  return
: labelok
  $ csize -> symvalue[nxttokval]
  $ nxttokval -> n ; call emitid
  $ colon -> tgtbyte ; call outbyte
  call outcrlf

  call gettoken
  return

  # =====
  # return detected, generate instruction
  # =====
: parsereturn
  # C3
  $ 195 -> n ; call emitdb
  $ semicolon -> tgtbyte ; call outbyte
  call emitreturn
  call outcrlf
  call gettoken
  return

  # =====
  # $ detected, find operand, generate instructions
  # =====
: parseload
  call gettoken

  call parseopd

  # 8B C1
  $ 139 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitmov
  $ space -> tgtbyte ; call outbyte
  call emiteax
  $ comma -> tgtbyte ; call outbyte
  call emitecx
  call outcrlf
  $ 8 * eax + ecx + 192 -> n ; call emitdb
  call outcrlf
  return

  # =====
  # -> detected, find variable, generate instructions
  # =====
: parsestore
  call gettoken
  $ nxttoken = tidentifier ? storeok
  call error
  return
: storeok
  call parsevar

  # 89 01
  $ 137 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitmov
  $ space    -> tgtbyte ; call outbyte
  $ lbracket -> tgtbyte ; call outbyte
  call emitecx
  $ rbracket -> tgtbyte ; call outbyte
  $ comma    -> tgtbyte ; call outbyte
  call emiteax
  call outcrlf
  $ 8 * eax + ecx -> n ; call emitdb
  call outcrlf
  return

  # =====
  # + detected, find operand, generate instructions
  # =====
: parseadd
  call gettoken

  call parseopd

  # 03 C1
  $ 3 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  call emiteax
  $ comma   -> tgtbyte ; call outbyte
  call emitecx
  call outcrlf
  $ 8 * eax + ecx + 192 -> n ; call emitdb
  call outcrlf
  return

  # =====
  # - detected, find variable, generate instructions
  # =====
: parsesub
  call gettoken

  call parseopd

  # 2B C1
  $ 43 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ letters -> tgtbyte ; call outbyte
  $ letteru -> tgtbyte ; call outbyte
  $ letterb -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  call emiteax
  $ comma   -> tgtbyte ; call outbyte
  call emitecx
  call outcrlf
  $ 8 * eax + ecx + 192 -> n ; call emitdb
  call outcrlf
  return

  # =====
  # * detected, find variable, generate instructions
  # =====
: parsemult
  call gettoken

  call parseopd

  # F7 E9
  $ 247 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ letteri -> tgtbyte ; call outbyte
  $ letterm -> tgtbyte ; call outbyte
  $ letteru -> tgtbyte ; call outbyte
  $ letterl -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  call emitecx
  call outcrlf
  $ ecx + 232 -> n ; call emitdb
  call outcrlf
  return

  # =====
  # / detected, find variable, generate instructions
  # =====
: parsediv
  call gettoken

  call parseopd

  # 99
  $ 153 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ letterc -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ letterq -> tgtbyte ; call outbyte
  call outcrlf

  # F7 F9
  $ 247 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ letteri -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ letteri -> tgtbyte ; call outbyte
  $ letterv -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  call emitecx
  call outcrlf
  $ ecx + 248 -> n ; call emitdb
  call outcrlf
  return

  # =====
  # & detected, find variable, generate instructions
  # =====
: parseand
  call gettoken

  call parseopd

  # 23 C1
  $ 35 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
  $ lettern -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  call emiteax
  $ comma   -> tgtbyte ; call outbyte
  call emitecx
  call outcrlf
  $ 8 * eax + ecx + 192 -> n ; call emitdb
  call outcrlf
  return

  # =====
  # | detected, find variable, generate instructions
  # =====
: parseor
  call gettoken

  call parseopd

  # 0B C1
  $ 11 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ lettero -> tgtbyte ; call outbyte
  $ letterr -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  call emiteax
  $ comma   -> tgtbyte ; call outbyte
  call emitecx
  call outcrlf
  $ 8 * eax + ecx + 192 -> n ; call emitdb
  call outcrlf
  return

  # =====
  # < detected, find variable, generate instructions
  # =====
: parselt
  call gettoken

  call parseopd

  # 3B C1
  $ 59 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitcmp
  $ space   -> tgtbyte ; call outbyte
  call emiteax
  $ comma   -> tgtbyte ; call outbyte
  call emitecx
  call outcrlf
  $ 8 * eax + ecx + 192 -> n ; call emitdb
  call outcrlf

  # 0F 9C C0
  $ 15 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitset
  $ letterl -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
  $ letterl -> tgtbyte ; call outbyte
  call outcrlf
  $ 156 -> n ; call emitdb
  call outcrlf
  $ 192 -> n ; call emitdb
  call outcrlf

  # 81 E0 00000001
  $ 129 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitand
  $ space        -> tgtbyte ; call outbyte
  call emiteax
  $ comma        -> tgtbyte ; call outbyte
  $ zerochar + 1 -> tgtbyte ; call outbyte
  call outcrlf
  $ eax + 224 -> n ; call emitdb
  call outcrlf
  $ 1 -> n ; call emitdd
  call outcrlf
  return

  # =====
  # <= detected, find variable, generate instructions
  # =====
: parsele
  call gettoken

  call parseopd

  # 3B C1
  $ 59 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitcmp
  $ space   -> tgtbyte ; call outbyte
  call emiteax
  $ comma   -> tgtbyte ; call outbyte
  call emitecx
  call outcrlf
  $ 8 * eax + ecx + 192 -> n ; call emitdb
  call outcrlf

  # 0F 9E C0
  $ 15 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitset
  $ letterl -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
  $ letterl -> tgtbyte ; call outbyte
  call outcrlf
  $ 158 -> n ; call emitdb
  call outcrlf
  $ 192 -> n ; call emitdb
  call outcrlf

  # 81 E0 00000001
  $ 129 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitand
  $ space        -> tgtbyte ; call outbyte
  call emiteax
  $ comma        -> tgtbyte ; call outbyte
  $ zerochar + 1 -> tgtbyte ; call outbyte
  call outcrlf
  $ eax + 224 -> n ; call emitdb
  call outcrlf
  $ 1 -> n ; call emitdd
  call outcrlf
  return

  # =====
  # = detected, find variable, generate instructions
  # =====
: parseeq
  call gettoken

  call parseopd

  # 3B C1
  $ 59 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitcmp
  $ space -> tgtbyte ; call outbyte
  call emiteax
  $ comma -> tgtbyte ; call outbyte
  call emitecx
  call outcrlf
  $ 8 * eax + ecx + 192 -> n ; call emitdb
  call outcrlf

  # 0F 94 C0
  $ 15 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitset
  $ lettere -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
  $ letterl -> tgtbyte ; call outbyte
  call outcrlf
  $ 148 -> n ; call emitdb
  call outcrlf
  $ 192 -> n ; call emitdb
  call outcrlf

  # 81 E0 00000001
  $ 129 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitand
  $ space        -> tgtbyte ; call outbyte
  call emiteax
  $ comma        -> tgtbyte ; call outbyte
  $ zerochar + 1 -> tgtbyte ; call outbyte
  call outcrlf
  $ eax + 224 -> n ; call emitdb
  call outcrlf
  $ 1 -> n ; call emitdd
  call outcrlf
  return

  # =====
  # <> detected, find variable, generate instructions
  # =====
: parsene
  call gettoken

  call parseopd

  # 3B C1
  $ 59 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitcmp
  $ space   -> tgtbyte ; call outbyte
  call emiteax
  $ comma   -> tgtbyte ; call outbyte
  call emitecx
  call outcrlf
  $ 8 * eax + ecx + 192 -> n ; call emitdb
  call outcrlf

  # 0F 95 C0
  $ 15 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitset
  $ lettern -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
  $ letterl -> tgtbyte ; call outbyte
  call outcrlf
  $ 149 -> n ; call emitdb
  call outcrlf
  $ 192 -> n ; call emitdb
  call outcrlf

  # 81 E0 00000001
  $ 129 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitand
  $ space        -> tgtbyte ; call outbyte
  call emiteax
  $ comma        -> tgtbyte ; call outbyte
  $ zerochar + 1 -> tgtbyte ; call outbyte
  call outcrlf
  $ eax + 224 -> n ; call emitdb
  call outcrlf
  $ 1 -> n ; call emitdd
  call outcrlf
  return

  # =====
  # > detected, find variable, generate instructions
  # =====
: parsegt
  call gettoken

  call parseopd

  # 3B C1
  $ 59 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitcmp
  $ space -> tgtbyte ; call outbyte
  call emiteax
  $ comma -> tgtbyte ; call outbyte
  call emitecx
  call outcrlf
  $ 8 * eax + ecx + 192 -> n ; call emitdb
  call outcrlf

  # 0F 9F C0
  $ 15 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitset
  $ letterg -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
  $ letterl -> tgtbyte ; call outbyte
  call outcrlf
  $ 159 -> n ; call emitdb
  call outcrlf
  $ 192 -> n ; call emitdb
  call outcrlf

  # 81 E0 00000001
  $ 129 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitand
  $ space        -> tgtbyte ; call outbyte
  call emiteax
  $ comma        -> tgtbyte ; call outbyte
  $ zerochar + 1 -> tgtbyte ; call outbyte
  call outcrlf
  $ eax + 224 -> n ; call emitdb
  call outcrlf
  $ 1 -> n ; call emitdd
  call outcrlf
  return

  # =====
  # >= detected, find variable, generate instructions
  # =====
: parsege
  call gettoken

  call parseopd

  # 3B C1
  $ 59 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitcmp
  $ space   -> tgtbyte ; call outbyte
  call emiteax
  $ comma   -> tgtbyte ; call outbyte
  call emitecx
  call outcrlf
  $ 8 * eax + ecx + 192 -> n ; call emitdb
  call outcrlf

  # 0F 9D C0
  $ 15 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitset
  $ letterg -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
  $ letterl -> tgtbyte ; call outbyte
  call outcrlf
  $ 157 -> n ; call emitdb
  call outcrlf
  $ 192 -> n ; call emitdb
  call outcrlf

  # 81 E0 00000001
  $ 129 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitand
  $ space        -> tgtbyte ; call outbyte
  call emiteax
  $ comma        -> tgtbyte ; call outbyte
  $ zerochar + 1 -> tgtbyte ; call outbyte
  call outcrlf
  $ eax + 224 -> n ; call emitdb
  call outcrlf
  $ 1 -> n ; call emitdd
  call outcrlf
  return
end

# =====
# expecting operand, if valid, generate instructions (load value into register ECX)
# =====
procedure parseopd
  $ nxttoken = tnumber ? foundnumtoken
  $ nxttoken = tidentifier ? foundidtoken
  call error
  return

: foundnumtoken
  call parsenumber
  return

: foundidtoken
  call parsevar

  # 8B 09
  $ 139 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitmov
  $ space    -> tgtbyte ; call outbyte
  call emitecx
  $ comma    -> tgtbyte ; call outbyte
  $ lbracket -> tgtbyte ; call outbyte
  call emitecx
  $ rbracket -> tgtbyte ; call outbyte
  call outcrlf
  $ 8 * ecx + ecx -> n ; call emitdb
  call outcrlf
end

# =====
# operand constant detected, generate instructions
# =====
procedure parsenumber
  # B9 data
  $ 184 + ecx -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  call emitmov
  $ space -> tgtbyte ; call outbyte
  call emitecx
  $ comma -> tgtbyte ; call outbyte
  $ nxttokval -> n ; call emitdec
  call outcrlf
  $ nxttokval -> n ; call emitdd
  call outcrlf

  call gettoken
end

# =====
# operand identifier detected, find subscript, if any, generate instructions (load address into ECX)
# =====
procedure parsevar
  $ symvalue[nxttokval] > minusone ? vardefined
  call error
: vardefined
  # 8D 8E offset
  $ 141 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ letterl -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
  $ space -> tgtbyte ; call outbyte
  call emitecx
  $ comma -> tgtbyte ; call outbyte
  $ lbracket -> tgtbyte ; call outbyte
  call emitesi
  $ plus     -> tgtbyte ; call outbyte
  $ symvalue[nxttokval] -> n ; call emitdec
  $ rbracket -> tgtbyte ; call outbyte
  $ semicolon -> tgtbyte ; call outbyte
  $ nxttokval -> n ; call emitid
  call outcrlf
  $ 8 * ecx + esi + 128 -> n ; call emitdb
  call outcrlf
  $ symvalue[nxttokval] -> n ; call emitdd
  call outcrlf

  call gettoken
  call parsesubscript
end

# =====
# [ detected, find name, generate instructions
# =====
procedure parsesubscript
  $ nxttoken = tlbracket ? subscriptok
  return
: subscriptok
  call gettoken
  $ nxttoken = tidentifier ? subscriptidok
  call error
  return
: subscriptidok
  $ symvalue[nxttokval] > minusone ? subscriptdefined
  call error
: subscriptdefined
  # 8B 95 offset
  $ 139 -> n ; call emitdb
  $ semicolon -> tgtbyte ; call outbyte
  $ letterm -> tgtbyte ; call outbyte
  $ lettero -> tgtbyte ; call outbyte
  $ letterv -> tgtbyte ; call outbyte
  $ space -> tgtbyte ; call outbyte
  call emitedx
  $ comma -> tgtbyte ; call outbyte
  $ lbracket -> tgtbyte ; call outbyte
  call emitesi
  $ plus     -> tgtbyte ; call outbyte
  $ symvalue[nxttokval] -> n ; call emitdec
  $ rbracket -> tgtbyte ; call outbyte
  $ semicolon -> tgtbyte ; call outbyte
  $ nxttokval -> n ; call emitid
  call outcrlf
  $ 8 * edx + esi + 128 -> n ; call emitdb
  call outcrlf
  $ symvalue[nxttokval] -> n ; call emitdd
  call outcrlf

  # C1 E2 02
  $ 193 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ letters      -> tgtbyte ; call outbyte
  $ letterh      -> tgtbyte ; call outbyte
  $ letterl      -> tgtbyte ; call outbyte
  $ space        -> tgtbyte ; call outbyte
  call emitedx
  $ comma        -> tgtbyte ; call outbyte
  $ zerochar + 2 -> tgtbyte ; call outbyte
  call outcrlf
  $ edx + 224 -> n ; call emitdb
  call outcrlf
  $ 2 -> n ; call emitdb
  call outcrlf

  # 03 CA
  $ 3 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  call emitecx
  $ comma   -> tgtbyte ; call outbyte
  call emitedx
  call outcrlf
  $ 8 * ecx + edx + 192 -> n ; call emitdb
  call outcrlf

  call gettoken

  $ nxttoken = trbracket ? subscriptendok
  return
: subscriptendok
  call gettoken
end

# ===== emit header =====

declare addrpsystem    # address of psystem variable (pointer to System subroutine)
declare addrmonitor    # address of monitor block (arguments to System subroutine)

procedure emitheader
  $ dot          -> tgtbyte ; call outbyte
  $ zerochar + 3 -> tgtbyte ; call outbyte
  $ zerochar + 8 -> tgtbyte ; call outbyte
  $ zerochar + 6 -> tgtbyte ; call outbyte
  call outcrlf

  $ dot     -> tgtbyte ; call outbyte
  $ letterm -> tgtbyte ; call outbyte
  $ lettero -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ letterl -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ letterf -> tgtbyte ; call outbyte
  $ letterl -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
  $ lettert -> tgtbyte ; call outbyte
  call outcrlf

  # == allocate psystem (pointer to System subroutine)

  $ dsize -> addrpsystem
  $ dsize + 4 -> dsize

  # == BEGIN monitor block

  $ dsize -> addrmonitor

  $ 0 -> ii $ letters      -> idstring[ii]
  $ 1 -> ii $ lettery      -> idstring[ii]
  $ 2 -> ii $ letters      -> idstring[ii]
  $ 3 -> ii $ letterf      -> idstring[ii]
  $ 4 -> ii $ lettern      -> idstring[ii]
  $ 5 -> ii $ 0            -> idstring[ii]
  call enterid
  $ dsize -> symvalue[nameindex]
  $ dsize + 4 -> dsize

  $ 0 -> ii $ letters      -> idstring[ii]
  $ 1 -> ii $ lettery      -> idstring[ii]
  $ 2 -> ii $ letters      -> idstring[ii]
  $ 3 -> ii $ lettera      -> idstring[ii]
  $ 4 -> ii $ letterr      -> idstring[ii]
  $ 5 -> ii $ letterg      -> idstring[ii]
  $ 6 -> ii $ zerochar + 1 -> idstring[ii]
  $ 7 -> ii $ 0            -> idstring[ii]
  call enterid
  $ dsize -> symvalue[nameindex]
  $ dsize + 4 -> dsize

  $ 0 -> ii $ letters      -> idstring[ii]
  $ 1 -> ii $ lettery      -> idstring[ii]
  $ 2 -> ii $ letters      -> idstring[ii]
  $ 3 -> ii $ lettera      -> idstring[ii]
  $ 4 -> ii $ letterr      -> idstring[ii]
  $ 5 -> ii $ letterg      -> idstring[ii]
  $ 6 -> ii $ zerochar + 2 -> idstring[ii]
  $ 7 -> ii $ 0            -> idstring[ii]
  call enterid
  $ dsize -> symvalue[nameindex]
  $ dsize + 4 -> dsize

  $ 0 -> ii $ letters      -> idstring[ii]
  $ 1 -> ii $ lettery      -> idstring[ii]
  $ 2 -> ii $ letters      -> idstring[ii]
  $ 3 -> ii $ lettera      -> idstring[ii]
  $ 4 -> ii $ letterr      -> idstring[ii]
  $ 5 -> ii $ letterr      -> idstring[ii]
  $ 6 -> ii $ lettera      -> idstring[ii]
  $ 7 -> ii $ lettery      -> idstring[ii]
  $ 8 -> ii $ 0            -> idstring[ii]
  call enterid
  $ dsize -> symvalue[nameindex]
  $ 4 * 4096 -> temp
  $ dsize + temp -> dsize

  # == END monitor block

  call emitpublic
  $ space      -> tgtbyte ; call outbyte
  $ underscore -> tgtbyte ; call outbyte
  call emitpgm
  call outcrlf

  call emitcode
  call outcrlf

  $ underscore -> tgtbyte ; call outbyte
  call emitpgm
  $ colon      -> tgtbyte ; call outbyte
  call outcrlf

  # magic

  $ letterd  -> tgtbyte ; call outbyte
  $ letterb  -> tgtbyte ; call outbyte
  $ space    -> tgtbyte ; call outbyte
  $ zerochar -> tgtbyte ; call outbyte
  $ comma    -> tgtbyte ; call outbyte
  $ zerochar -> tgtbyte ; call outbyte
  $ comma    -> tgtbyte ; call outbyte
  $ zerochar -> tgtbyte ; call outbyte
  $ comma    -> tgtbyte ; call outbyte
  $ zerochar -> tgtbyte ; call outbyte
  call outcrlf

  # header size

  $ letterd      -> tgtbyte ; call outbyte
  $ letterd      -> tgtbyte ; call outbyte
  $ space        -> tgtbyte ; call outbyte
  $ zerochar + 1 -> tgtbyte ; call outbyte
  $ zerochar + 6 -> tgtbyte ; call outbyte
  call outcrlf

  # compiler/runtime version

  $ letterd      -> tgtbyte ; call outbyte
  $ letterd      -> tgtbyte ; call outbyte
  $ space        -> tgtbyte ; call outbyte
  $ zerochar     -> tgtbyte ; call outbyte
  $ zerochar + 0 -> tgtbyte ; call outbyte
  $ zerochar + 1 -> tgtbyte ; call outbyte
  $ zerochar + 0 -> tgtbyte ; call outbyte
  $ zerochar + 0 -> tgtbyte ; call outbyte
  $ letterh      -> tgtbyte ; call outbyte
  call outcrlf

  # code size

  $ letterd -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ letterc -> tgtbyte ; call outbyte
  $ letters -> tgtbyte ; call outbyte
  $ letteri -> tgtbyte ; call outbyte
  $ letterz -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  call outcrlf

  # data size

  $ letterd -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ letters -> tgtbyte ; call outbyte
  $ letteri -> tgtbyte ; call outbyte
  $ letterz -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  call outcrlf

  # start of code

  $ 0 -> ii $ dollar -> idstring[ii]
  $ 1 -> ii $ dollar -> idstring[ii]
  $ 2 -> ii $ 0      -> idstring[ii]
  call enterid

  # E9 displ
  $ 233 -> n ; call emitdb
  $ semicolon -> tgtbyte ; call outbyte
  $ letterj -> tgtbyte ; call outbyte
  $ letterm -> tgtbyte ; call outbyte
  $ letterp -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ nameindex -> n ; call emitid
  call outcrlf
  $ nameindex -> n ; call emitlabeldisp
  call outcrlf

  $ 0 -> ii $ letters      -> idstring[ii]
  $ 1 -> ii $ lettery      -> idstring[ii]
  $ 2 -> ii $ letters      -> idstring[ii]
  $ 3 -> ii $ lettert      -> idstring[ii]
  $ 4 -> ii $ lettere      -> idstring[ii]
  $ 5 -> ii $ letterm      -> idstring[ii]
  $ 6 -> ii $ 0            -> idstring[ii]
  call enterid
  $ csize -> symvalue[nameindex]

  $ nameindex -> n ; call emitid
  $ colon      -> tgtbyte ; call outbyte
  call outcrlf

  # 55
  $ 80 + ebp -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ letterp    -> tgtbyte ; call outbyte
  $ letteru    -> tgtbyte ; call outbyte
  $ letters    -> tgtbyte ; call outbyte
  $ letterh    -> tgtbyte ; call outbyte
  $ space      -> tgtbyte ; call outbyte
  $ lettere    -> tgtbyte ; call outbyte
  $ letterb    -> tgtbyte ; call outbyte
  $ letterp    -> tgtbyte ; call outbyte
  call outcrlf

  # 8B EC
  $ 139 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ letterm -> tgtbyte ; call outbyte
  $ lettero -> tgtbyte ; call outbyte
  $ letterv -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ letterb -> tgtbyte ; call outbyte
  $ letterp -> tgtbyte ; call outbyte
  $ comma   -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ letters -> tgtbyte ; call outbyte
  $ letterp -> tgtbyte ; call outbyte
  call outcrlf
  $ 8 * ebp + esp + 192 -> n ; call emitdb
  call outcrlf

  # 8D 8E offset
  $ 141 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ letterl -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  call emitecx
  $ comma   -> tgtbyte ; call outbyte
  $ lbracket -> tgtbyte ; call outbyte
  call emitesi
  $ plus     -> tgtbyte ; call outbyte
  $ addrmonitor -> n ; call emitdec
  $ rbracket -> tgtbyte ; call outbyte
  call outcrlf
  $ 8 * ecx + esi + 128 -> n ; call emitdb
  call outcrlf
  $ addrmonitor -> n ; call emitdd
  call outcrlf

  # 51
  $ 80 + ecx -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ letterp -> tgtbyte ; call outbyte
  $ letteru -> tgtbyte ; call outbyte
  $ letters -> tgtbyte ; call outbyte
  $ letterh -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  call emitecx
  call outcrlf

  # FF 96 offset
  $ 255 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ letterc -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
  $ letterl -> tgtbyte ; call outbyte
  $ letterl -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ letterw -> tgtbyte ; call outbyte
  $ lettero -> tgtbyte ; call outbyte
  $ letterr -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ letterp -> tgtbyte ; call outbyte
  $ lettert -> tgtbyte ; call outbyte
  $ letterr -> tgtbyte ; call outbyte
  $ lbracket -> tgtbyte ; call outbyte
  call emitesi
  $ plus     -> tgtbyte ; call outbyte
  $ addrpsystem -> n ; call emitdec
  $ rbracket -> tgtbyte ; call outbyte
  call outcrlf
  $ 144 + esi -> n ; call emitdb
  call outcrlf
  $ addrpsystem -> n ; call emitdd
  call outcrlf

  # 8B E5
  $ 139 -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ letterm -> tgtbyte ; call outbyte
  $ lettero -> tgtbyte ; call outbyte
  $ letterv -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ letters -> tgtbyte ; call outbyte
  $ letterp -> tgtbyte ; call outbyte
  $ comma   -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ letterb -> tgtbyte ; call outbyte
  $ letterp -> tgtbyte ; call outbyte
  call outcrlf
  $ 8 * esp + ebp + 192 -> n ; call emitdb
  call outcrlf

  # 5D
  $ 88 + ebp -> n ; call emitdb
  $ semicolon  -> tgtbyte ; call outbyte
  $ letterp -> tgtbyte ; call outbyte
  $ lettero -> tgtbyte ; call outbyte
  $ letterp -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ letterb -> tgtbyte ; call outbyte
  $ letterp -> tgtbyte ; call outbyte
  call outcrlf

  # C3
  $ 195 -> n ; call emitdb
  $ semicolon -> tgtbyte ; call outbyte
  call emitreturn
  call outcrlf

  $ 0 -> ii $ dollar -> idstring[ii]
  $ 1 -> ii $ dollar -> idstring[ii]
  $ 2 -> ii $ 0      -> idstring[ii]
  call searchid
  $ csize -> symvalue[nameindex]

  $ nameindex -> n ; call emitid
  $ colon  -> tgtbyte ; call outbyte
  call outcrlf

  call emitpgm
  $ colon   -> tgtbyte ; call outbyte
  call outcrlf

  # 89 86 displ
  $ 137 -> n ; call emitdb
  $ semicolon -> tgtbyte ; call outbyte
  call emitmov
  $ space   -> tgtbyte ; call outbyte
  $ lbracket -> tgtbyte ; call outbyte
  call emitesi
  $ plus     -> tgtbyte ; call outbyte
  $ addrpsystem -> n ; call emitdec
  $ rbracket -> tgtbyte ; call outbyte
  $ comma   -> tgtbyte ; call outbyte
  call emiteax
  call outcrlf
  $ 8 * eax + esi + 128 -> n ; call emitdb
  call outcrlf
  $ addrpsystem -> n ; call emitdd
  call outcrlf
end

# =====

procedure emitpublic
  $ letterp -> tgtbyte ; call outbyte
  $ letteru -> tgtbyte ; call outbyte
  $ letterb -> tgtbyte ; call outbyte
  $ letterl -> tgtbyte ; call outbyte
  $ letteri -> tgtbyte ; call outbyte
  $ letterc -> tgtbyte ; call outbyte
end

# =====

procedure emitpgm
  $ letterp -> tgtbyte ; call outbyte
  $ letterg -> tgtbyte ; call outbyte
  $ letterm -> tgtbyte ; call outbyte
end

# ===== emit trailer =====

procedure emittrailer
  $ letterc -> tgtbyte ; call outbyte
  $ letters -> tgtbyte ; call outbyte
  $ letteri -> tgtbyte ; call outbyte
  $ letterz -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ letterq -> tgtbyte ; call outbyte
  $ letteru -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ csize -> n ; call emitdec
  call outcrlf

  $ semicolon -> tgtbyte ; call outbyte
  $ csize -> n ; call emithex
  call outcrlf

  $ letterd -> tgtbyte ; call outbyte
  $ letters -> tgtbyte ; call outbyte
  $ letteri -> tgtbyte ; call outbyte
  $ letterz -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ letterq -> tgtbyte ; call outbyte
  $ letteru -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ dsize -> n ; call emitdec
  call outcrlf

  $ semicolon -> tgtbyte ; call outbyte
  $ dsize -> n ; call emithex
  call outcrlf

  $ lettere -> tgtbyte ; call outbyte
  $ lettern -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  call outcrlf
end

# ===== emit .code =====

procedure emitcode
  $ dot     -> tgtbyte ; call outbyte
  $ letterc -> tgtbyte ; call outbyte
  $ lettero -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
end

# ===== emit .data =====

procedure emitdata
  $ dot     -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
  $ lettert -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
end

# ===== emit mov =====

procedure emitmov
  $ letterm -> tgtbyte ; call outbyte
  $ lettero -> tgtbyte ; call outbyte
  $ letterv -> tgtbyte ; call outbyte
end

# ===== emit ret =====

procedure emitreturn
  $ letterr -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ lettert -> tgtbyte ; call outbyte
end

# ===== emit cmp =====

procedure emitcmp
  $ letterc -> tgtbyte ; call outbyte
  $ letterm -> tgtbyte ; call outbyte
  $ letterp -> tgtbyte ; call outbyte
end

# ===== emit set =====

procedure emitset
  $ letters -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ lettert -> tgtbyte ; call outbyte
end

# ===== emit and =====

procedure emitand
  $ lettera -> tgtbyte ; call outbyte
  $ lettern -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
end

# =====

procedure emitdclvar
  $ space   -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  $ query   -> tgtbyte ; call outbyte
end

# =====

procedure emitoffset
  $ lettero -> tgtbyte ; call outbyte
  $ letterf -> tgtbyte ; call outbyte
  $ letterf -> tgtbyte ; call outbyte
  $ letters -> tgtbyte ; call outbyte
  $ lettere -> tgtbyte ; call outbyte
  $ lettert -> tgtbyte ; call outbyte
end

# =====

procedure emiteax
  $ lettere -> tgtbyte ; call outbyte
  $ lettera -> tgtbyte ; call outbyte
  $ letterx -> tgtbyte ; call outbyte
end

# =====

procedure emitecx
  $ lettere -> tgtbyte ; call outbyte
  $ letterc -> tgtbyte ; call outbyte
  $ letterx -> tgtbyte ; call outbyte
end

# =====

procedure emitedx
  $ lettere -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ letterx -> tgtbyte ; call outbyte
end

# =====

procedure emitesi
  $ lettere -> tgtbyte ; call outbyte
  $ letters -> tgtbyte ; call outbyte
  $ letteri -> tgtbyte ; call outbyte
end

# =====
# ===== byte value is in n, n is destroyed

procedure emitdb
  $ n -> binval

  $ letterd -> tgtbyte ; call outbyte
  $ letterb -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  call emitdec

  $ csize + 1 -> csize

  $ binval -> tgtbyte ; call outprebin
end

# =====
# ===== value is in n, n is destroyed

procedure emitdd
  $ n -> binval

  $ letterd -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  call emitdec

  $ csize + 4 -> csize

  $ binval -> n ; call int2hex
  $ 0 -> ii $ 1 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outprebin
  $ 2 -> ii $ 3 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outprebin
  $ 4 -> ii $ 5 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outprebin
  $ 6 -> ii $ 7 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outprebin
end

# =====
# ===== target label index is in n, n is destroyed

procedure emitlabeldisp
  $ n -> binval

  $ letterd -> tgtbyte ; call outbyte
  $ letterd -> tgtbyte ; call outbyte
  $ space   -> tgtbyte ; call outbyte
  call emitid
  $ minus   -> tgtbyte ; call outbyte
  $ dollar  -> tgtbyte ; call outbyte
  $ minus   -> tgtbyte ; call outbyte
  $ zerochar + 4 -> tgtbyte ; call outbyte

  $ csize + 4 -> csize

  $ 0 -> n   # assume forward jump

  $ binval = minusone ? skipdisp  # oops, didn't enter after search
  $ symvalue[binval] > minusone ? skipdisptable

  # undefined, enter information

  $ csize - 4 -> n ; call int2hex
  $ 0 -> ii $ 1 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outtbl
  $ 2 -> ii $ 3 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outtbl
  $ 4 -> ii $ 5 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outtbl
  $ 6 -> ii $ 7 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outtbl

  $ binval -> n ; call int2hex
  $ 0 -> ii $ 1 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outtbl
  $ 2 -> ii $ 3 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outtbl
  $ 4 -> ii $ 5 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outtbl
  $ 6 -> ii $ 7 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outtbl

: skipdisptable

  $ 0 -> n   # assume forward jump

  $ symvalue[binval] -> binval
  $ binval = minusone ? skipdisp

  $ binval - csize -> n  # backward jump, can calculate displacement

: skipdisp

  call int2hex
  $ 0 -> ii $ 1 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outprebin
  $ 2 -> ii $ 3 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outprebin
  $ 4 -> ii $ 5 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outprebin
  $ 6 -> ii $ 7 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outprebin
end

# =====
# ===== name index is in n

procedure emitid
  $ underscore -> tgtbyte
  call outbyte
  $ symname[n] -> k
: emitidloop
  $ namepool[k] -> tgtbyte
  $ tgtbyte = 0 ? exitemitid
  call outbyte
  $ k + 1 -> k
  goto emitidloop

: exitemitid
end

# ===== write a number in decimal format to the target file =====
# ===== value is in n, n is destroyed

procedure emitdec
  call int2dec
  $ 9 -> k
  $ 10 -> temp
  $ decarray[temp] = 0 ? emitdec01
  $ minus -> tgtbyte ; call outbyte
: emitdec01            # skip leading zeros
  $ decarray[k] > 0 ? emitdec02
  $ k - 1 -> k
  $ k > 0 ? emitdec01    # except the last zero
: emitdec02
  $ zerochar + decarray[k] -> tgtbyte ; call outbyte
  $ k - 1 -> k
  $ k > minusone ? emitdec02
end

# ===== write a number in hexadecimal format to the target file =====
# ===== value is in n, n is destroyed

procedure emithex
  call int2hex
  $ 7 -> k
: emithex01
  $ hexarray[k] -> temp
  $ hexdigit[temp] -> tgtbyte ; call outbyte
  $ k - 1 -> k
  $ k > minusone ? emithex01
end

# ===== finish the raw binary executable =====

declare phdrsize

declare fhdrsize
declare shdrsize
declare rscnsize
declare stabentrysize

procedure finishbin
  $ 20 -> phdrsize

  $ 20 -> fhdrsize
  $ 40 -> shdrsize
  $  0 -> rscnsize
  $ 18 -> stabentrysize

  # COFF file header
  call generatefileheader

  # COFF optional header
  # -- not needed, we are not generating an executable file --

  # COFF section headers
  call generatesectionheaders

  # COFF raw data sections
  call generatecodesection

  # COFF relocation table
  # -- not needed, code and data references are position-independent --

  # COFF line number table
  # -- we are not generating any line number information --

  # COFF symbol table
  call generatesymboltable

  # COFF string table
  # the first four bytes is the size of the table
  #   including the string table size field
  # there are no strings because we aren't placing
  #   any long (> 8 chars) names in the COFF file

  $ 4 -> n ; call outbindword

end

# ===== generate the COFF file header =====

procedure generatefileheader
  # 2 bytes - magic number (signature)
  # 0x014C is the one for Microsoft software
  # on Intel's IA-32 machines in 32-bit flat memory model

  $ 0x014c -> n ; call outbinword

  # 2 bytes - number of sections
  # we define only 1 section, the code section

  $ 1 -> n ; call outbinword

  # 4 bytes - time/date stamp
  # getting a correct value requires calling a Win32 API
  # we set it to an arbitrarily old value for now

  $ 0 -> n ; call outbindword

  # 4 bytes - file offset of symbol table
  # location of the symbol table within the COFF file

  $ fhdrsize + shdrsize + phdrsize + csize + rscnsize -> n ; call outbindword

  # 4 bytes - number of symbols in symbol table
  # we are exporting 1 external (public) symbol

  $ 1 -> n ; call outbindword

  # 2 bytes - size of optional header
  # object files dont need the optional header

  $ 0 -> n ; call outbinword

  # 2 bytes - file header flags (characteristics)
  # MASM sets this field to all zeroes
  # apparently the linker doesnt need these
  # most options refer to executable characteristics only

  $ 0x0000 -> n ; call outbinword
end

# ===== generate the COFF section headers =====

procedure generatesectionheaders
  # 8 bytes - section name
  # left justified, zero padded

  $ dot     -> tgtbyte ; call outbin
  $ lettert -> tgtbyte ; call outbin
  $ lettere -> tgtbyte ; call outbin
  $ letterx -> tgtbyte ; call outbin
  $ lettert -> tgtbyte ; call outbin
  $ 0       -> tgtbyte ; call outbin
  $ 0       -> tgtbyte ; call outbin
  $ 0       -> tgtbyte ; call outbin

  # 4 bytes - physical start address of section
  # this only makes sense in an executable
  # MASM sets this field as if the first section started at 0
  #   and succeeding sections follow end-to-end
  #
  # it's not clear how this field is set when there's an ORG that
  #   creates a gap at the beginning of a section
  # as we're not building an assembler, we'll just set normal offsets here

  $ 0 -> n ; call outbindword

  # 4 bytes - virtual start address of section
  # sometimes this is set equal to the physical address
  # all relocations by the linker is based on this field
  # MASM simply sets this to 0 for each section
  #
  # it's not clear how this field is set when there's an ORG that
  #   creates a gap at the beginning of a section
  # as we're not building an assembler, we'll just set normal offsets here

  $ 0 -> n ; call outbindword

  # 4 bytes - size of section (number of raw data bytes)

  $ phdrsize + csize -> n ; call outbindword

  # 4 bytes - file offset of raw data

  $ fhdrsize + shdrsize -> n ; call outbindword

  # 4 bytes - file offset of relocation info
  # our code doesn't need relocation

  $ 0 -> n ; call outbindword

  # 4 bytes - file offset of line number info
  # line number information not created

  $ 0 -> n ; call outbindword

  # 2 bytes - number of relocation entries

  $ 0 -> n ; call outbinword

  # 2 bytes - number of line number entries

  $ 0 -> n ; call outbinword

  # 4 bytes - section header flags (characteristics)
  # our code section contains machine instructions and is executable and readable
  # MASM model FLAT sets .text alignment to 4 bytes, so we'll set it that way, too

  $ 0x60300020 -> n ; call outbindword

# Flags

#  data kind
# 0x00000020	Section contains executable code
# 0x00000040	Section contains initialized data
# 0x00000080	Section contains uninitialized data
#  alignment
# 0x00100000	1 byte alignment
# 0x00200000	2 byte alignment
# 0x00300000	4 byte alignment
# 0x00400000	8 byte alignment
# 0x00500000	16 byte alignment - default alignment
# 0x00600000	32 byte alignment
# 0x00700000	64 byte alignment
# 0x00800000	128 byte alignment
# 0x00900000	256 byte alignment
# 0x00A00000	512 byte alignment
# 0x00B00000	1024 byte alignment
# 0x00C00000	2048 byte alignment
# 0x00D00000	4096 byte alignment
# 0x00E00000	8192 byte alignment
# 0x00F00000	-- Not used --
#  permissions
# 0x20000000	Section can be executed
# 0x40000000	Section can be read
# 0x80000000	Section can be written
end

# ===== generate the COFF symbol table =====

procedure generatesymboltable
  # 8 bytes - symbol name
  # left justified, zero padded
  # if the first four bytes are zero,
  #   the symbol name string is stored in the string table
  #   the second four bytes would be an index into the string table

  $ underscore -> tgtbyte ; call outbin
  $ letterp -> tgtbyte ; call outbin
  $ letterg -> tgtbyte ; call outbin
  $ letterm -> tgtbyte ; call outbin
  $ 0       -> tgtbyte ; call outbin
  $ 0       -> tgtbyte ; call outbin
  $ 0       -> tgtbyte ; call outbin
  $ 0       -> tgtbyte ; call outbin

  # 4 bytes - section offset

  $ 0 -> n ; call outbindword

  # 2 bytes - section number
  # section numbers start from 1

  $ 1 -> n ; call outbinword

  # 2 bytes - data type
  # MASM generates data type of "function of type null" for code labels

  $ 0x20 -> n ; call outbinword

  # 1 byte - storage class
  # all external symbols (imported or exported) have the "external" storage class

  $ 2 -> tgtbyte ; call outbin

  # 1 byte - number of auxiliary symbols

  $ 0 -> tgtbyte ; call outbin
end

declare loc
declare nextloc
declare nextsymindex

# ===== generate COFF raw data for the code section =====

procedure generatecodesection
  # magic

  $ 0 -> n ; call outbindword

  # header size

  $ 16 -> n ; call outbindword

  # compiler/runtime version

  $ 0 * 256 + 3 -> n
  $ 65536 * n -> n
  $ 1 * 256 + 1 + n -> n
  call outbindword

  # code size

  $ csize -> n ; call outbindword

  # data size

  $ dsize -> n ; call outbindword

  $ 0 -> loc
  $ minusone -> nextloc
  $ minusone -> nextsymindex

: finishbin01

  call intbl
  $ tgtbyte = minusone ? noentry
             $            tgtbyte           -> nextloc
  call intbl $ 256      * tgtbyte + nextloc -> nextloc
  call intbl $ 65536    * tgtbyte + nextloc -> nextloc
  call intbl $ 16777216 * tgtbyte + nextloc -> nextloc

  call intbl $            tgtbyte                -> nextsymindex
  call intbl $ 256      * tgtbyte + nextsymindex -> nextsymindex
  call intbl $ 65536    * tgtbyte + nextsymindex -> nextsymindex
  call intbl $ 16777216 * tgtbyte + nextsymindex -> nextsymindex
: noentry

: finishbin02

  call inprebin
  $ tgtbyte = minusone ? bindone

  $ loc = nextloc ? fixup

  call outbin

  $ loc + 1 -> loc
  goto finishbin02

: fixup

  # read in rest of filler bytes
  call inprebin
  call inprebin
  call inprebin

  $ symvalue[nextsymindex] - loc - 4 -> n ; call outbindword

  $ loc + 4 -> loc
  goto finishbin01

: bindone
end

# ===== output two bytes little-endian (Intel WORD) to bin file =====
# ===== value is in n, n is destroyed

procedure outbinword
  call int2hex
  $ 0 -> ii $ 1 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outbin
  $ 2 -> ii $ 3 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outbin
end

# ===== output four bytes little-endian (Intel DWORD) to bin file =====
# ===== value is in n, n is destroyed

procedure outbindword
  call int2hex
  $ 0 -> ii $ 1 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outbin
  $ 2 -> ii $ 3 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outbin
  $ 4 -> ii $ 5 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outbin
  $ 6 -> ii $ 7 -> ii1
  $ hexarray[ii1] * 16 + hexarray[ii] -> tgtbyte ; call outbin
end

# ===== get one token =====

procedure gettoken

: testwhite
  $ nxtchar = space ? skipwhite
  $ nxtchar = tab ? skipwhite
  $ nxtchar = cr ? skipwhite
  $ nxtchar = lf ? skipwhite
  goto endwhite
: skipwhite
  call getchar
  goto testwhite
: endwhite

  $ nxtchar < lettera ? notid
  $ nxtchar > letterz ? notid
  goto getid
: notid

  $ nxtchar < zerochar ? notnum
  $ nxtchar > ninechar ? notnum
  goto getnum
: notnum

  $ nxtchar = sharp ? skipcomment
  $ nxtchar = minusone ? lexeof
  $ nxtchar = semicolon ? lexsemicolon
  $ nxtchar = query ? lexifgoto
  $ nxtchar = colon ? lexlabel
  $ nxtchar = dollar ? lexload
  $ nxtchar = plus ? lexadd
  $ nxtchar = minus ? lexsubtract
  $ nxtchar = star ? lexmultiply
  $ nxtchar = slash ? lexdivide
  $ nxtchar = and ? lexand
  $ nxtchar = or ? lexor
  $ nxtchar = less ? lexless
  $ nxtchar = equal ? lexequal
  $ nxtchar = greater ? lexgreater
  $ nxtchar = lbracket ? lexlbracket
  $ nxtchar = rbracket ? lexrbracket

  $ tbad -> nxttoken
  call getchar
  return

# =====
: lexeof
  $ teof -> nxttoken
  call getchar
  return

: lexsemicolon
  $ tsemicolon -> nxttoken
  call getchar
  return

: lexifgoto
  $ tifgoto -> nxttoken
  call getchar
  return

: lexlabel
  $ tlabel -> nxttoken
  call getchar
  return

: lexload
  $ tload -> nxttoken
  call getchar
  return

: lexadd
  $ tadd -> nxttoken
  call getchar
  return

: lexsubtract
  $ tsubtract -> nxttoken
  call getchar
  $ nxtchar = greater ? lexarrow
  return

: lexarrow
  $ tstore -> nxttoken
  call getchar
  return

: lexmultiply
  $ tmultiply -> nxttoken
  call getchar
  return

: lexdivide
  $ tdivide -> nxttoken
  call getchar
  return

: lexand
  $ tand -> nxttoken
  call getchar
  return

: lexor
  $ tor -> nxttoken
  call getchar
  return

: lexless
  $ tless -> nxttoken
  call getchar
  $ nxtchar = equal ? lexlessequal
  $ nxtchar = greater ? lexnotequal
  return

: lexlessequal
  $ tlessequal -> nxttoken
  call getchar
  return

: lexnotequal
  $ tnotequal -> nxttoken
  call getchar
  return

: lexequal
  $ tequal -> nxttoken
  call getchar
  return

: lexgreater
  $ tgreater -> nxttoken
  call getchar
  $ nxtchar = equal ? lexgreaterequal
  return

: lexgreaterequal
  $ tgreaterequal -> nxttoken
  call getchar
  return

: lexlbracket
  $ tlbracket -> nxttoken
  call getchar
  return

: lexrbracket
  $ trbracket -> nxttoken
  call getchar
  return

# =====
: skipcomment
  call getchar
  $ nxtchar = cr ? testwhite
  $ nxtchar = lf ? testwhite
  goto skipcomment

# =====
: getnum

  $ 0 -> i
  $ 0 -> nxttokval

  $ nxtchar = zerochar ? iszeroprefix

: stilldec
  $ 10 * nxttokval + nxtchar - zerochar -> nxttokval
  $ i + 1 -> i
  call getchar
  $ nxtchar < zerochar ? enddec
  $ nxtchar > ninechar ? enddec
  goto stilldec
: enddec

  $ tnumber -> nxttoken
  return

: iszeroprefix
  call getchar
  $ nxtchar = letterx ? gethex
  $ nxtchar < zerochar ? enddec
  $ nxtchar > ninechar ? enddec
  goto stilldec

: gethex
  call getchar
  $ nxtchar < zerochar ? hexerror
  $ nxtchar > ninechar ? stillhex00
  goto stillhex

: stillhex00
  $ nxtchar < lettera ? hexerror
  $ nxtchar > letterf ? hexerror

: stillhex
  $ nxtchar < zerochar ? endhex
  $ nxtchar > ninechar ? stillhex01
  $ 16 * nxttokval + nxtchar - zerochar -> nxttokval
  goto stillhex02
: stillhex01
  $ nxtchar < lettera ? endhex
  $ nxtchar > letterf ? endhex
  $ 16 * nxttokval + nxtchar - lettera + 10 -> nxttokval
: stillhex02
  $ i + 1 -> i
  call getchar
  goto stillhex
: endhex

  $ tnumber -> nxttoken
  return

: hexerror
  call error
  $ tnumber -> nxttoken
  return

# =====
: getid

  $ 0 -> i

: stillid
  $ nxtchar -> idstring[i]
  $ i + 1 -> i
  call getchar
  $ nxtchar < lettera ? notletter
  $ nxtchar > letterz ? notletter
  goto stillid
: notletter
  $ nxtchar < zerochar ? endid
  $ nxtchar > ninechar ? endid
  goto stillid
: endid

  $ 0 -> idstring[i]

  call searchkeyword
  $ nxttoken = tidentifier ? notkeyword
  return

: notkeyword
  call searchid
  $ nameindex > minusone ? idfound
  call enterid
: idfound
  $ nameindex -> nxttokval
end

# ===== search for keyword =====
# ===== return token number in nxttoken, else tidentifier if not found

procedure searchkeyword
  $ 0 -> ii $ idstring[ii] <> letterm ? kwnotmain
  $ 1 -> ii $ idstring[ii] <> lettera ? kwnotmain
  $ 2 -> ii $ idstring[ii] <> letteri ? kwnotmain
  $ 3 -> ii $ idstring[ii] <> lettern ? kwnotmain
  $ 4 -> ii $ idstring[ii] <> 0 ? kwnotmain
  $ tmain -> nxttoken
  return
: kwnotmain

  $ 0 -> ii $ idstring[ii] <> letterp ? kwnotprocedure
  $ 1 -> ii $ idstring[ii] <> letterr ? kwnotprocedure
  $ 2 -> ii $ idstring[ii] <> lettero ? kwnotprocedure
  $ 3 -> ii $ idstring[ii] <> letterc ? kwnotprocedure
  $ 4 -> ii $ idstring[ii] <> lettere ? kwnotprocedure
  $ 5 -> ii $ idstring[ii] <> letterd ? kwnotprocedure
  $ 6 -> ii $ idstring[ii] <> letteru ? kwnotprocedure
  $ 7 -> ii $ idstring[ii] <> letterr ? kwnotprocedure
  $ 8 -> ii $ idstring[ii] <> lettere ? kwnotprocedure
  $ 9 -> ii $ idstring[ii] <> 0 ? kwnotprocedure
  $ tprocedure -> nxttoken
  return
: kwnotprocedure

  $ 0 -> ii $ idstring[ii] <> lettere ? kwnotend
  $ 1 -> ii $ idstring[ii] <> lettern ? kwnotend
  $ 2 -> ii $ idstring[ii] <> letterd ? kwnotend
  $ 3 -> ii $ idstring[ii] <> 0 ? kwnotend
  $ tend -> nxttoken
  return
: kwnotend

  $ 0 -> ii $ idstring[ii] <> letterd ? kwnotdeclare
  $ 1 -> ii $ idstring[ii] <> lettere ? kwnotdeclare
  $ 2 -> ii $ idstring[ii] <> letterc ? kwnotdeclare
  $ 3 -> ii $ idstring[ii] <> letterl ? kwnotdeclare
  $ 4 -> ii $ idstring[ii] <> lettera ? kwnotdeclare
  $ 5 -> ii $ idstring[ii] <> letterr ? kwnotdeclare
  $ 6 -> ii $ idstring[ii] <> lettere ? kwnotdeclare
  $ 7 -> ii $ idstring[ii] <> 0 ? kwnotdeclare
  $ tdeclare -> nxttoken
  return
: kwnotdeclare

  $ 0 -> ii $ idstring[ii] <> letterg ? kwnotgoto
  $ 1 -> ii $ idstring[ii] <> lettero ? kwnotgoto
  $ 2 -> ii $ idstring[ii] <> lettert ? kwnotgoto
  $ 3 -> ii $ idstring[ii] <> lettero ? kwnotgoto
  $ 4 -> ii $ idstring[ii] <> 0 ? kwnotgoto
  $ tgoto -> nxttoken
  return
: kwnotgoto

  $ 0 -> ii $ idstring[ii] <> letterc ? kwnotcall
  $ 1 -> ii $ idstring[ii] <> lettera ? kwnotcall
  $ 2 -> ii $ idstring[ii] <> letterl ? kwnotcall
  $ 3 -> ii $ idstring[ii] <> letterl ? kwnotcall
  $ 4 -> ii $ idstring[ii] <> 0 ? kwnotcall
  $ tcall -> nxttoken
  return
: kwnotcall

  $ 0 -> ii $ idstring[ii] <> letterr ? kwnotreturn
  $ 1 -> ii $ idstring[ii] <> lettere ? kwnotreturn
  $ 2 -> ii $ idstring[ii] <> lettert ? kwnotreturn
  $ 3 -> ii $ idstring[ii] <> letteru ? kwnotreturn
  $ 4 -> ii $ idstring[ii] <> letterr ? kwnotreturn
  $ 5 -> ii $ idstring[ii] <> lettern ? kwnotreturn
  $ 6 -> ii $ idstring[ii] <> 0 ? kwnotreturn
  $ treturn -> nxttoken
  return
: kwnotreturn

  $ tidentifier -> nxttoken
end

# ===== search for identifier in symbol table =====
# ===== return symbol table index in nameindex, else -1 if not found

procedure searchid
  $ 0 -> nameindex
: keepsearchingid
  call equalid
  $ temp ? searchidfound
  $ nameindex + 1 -> nameindex
  $ nameindex < numsym ? keepsearchingid
  $ minusone -> nameindex
: searchidfound
end

# ===== compare symbol table name with last scanned identifier =====
# ===== return 1 if equal, else 0

procedure equalid
  $ 0 -> idlength
  $ symname[nameindex] -> eqindex
: compareid
  $ idstring[idlength] -> temp
  $ temp = namepool[eqindex] ? idstilleq
  $ 0 -> temp
  return
: idstilleq
  $ idlength + 1 -> idlength
  $ eqindex + 1 -> eqindex
  $ temp > 0 ? compareid
  $ 1 -> temp
end

# ===== create a new identifier in the symbol table =====
# ===== return symbol table index in nameindex

procedure enterid
  $ numsym = numsymmax ? symoverflow

  $ numsym -> nameindex
  $ namepoolsize -> symname[nameindex]
  $ minusone -> symvalue[nameindex]
  $ numsym + 1 -> numsym
  $ 0 -> idlength
: enterid01
  $ namepoolsize = namepoolmax ? nameoverflow
  $ idstring[idlength] -> temp
  $ temp -> namepool[namepoolsize]
  $ idlength + 1 -> idlength
  $ namepoolsize + 1 -> namepoolsize
  $ temp > 0 ? enterid01
  return

: symoverflow
  $ 1 -> errorflag

  $ star    -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ letters -> lstchar ; call writechar
  $ lettery -> lstchar ; call writechar
  $ letterm -> lstchar ; call writechar
  $ lettero -> lstchar ; call writechar
  $ letterf -> lstchar ; call writechar
  $ letterl -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ lettere -> lstchar ; call writechar
  $ letterr -> lstchar ; call writechar
  $ letterr -> lstchar ; call writechar
  $ lettero -> lstchar ; call writechar
  $ letterr -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  call writecrlf
  return
: nameoverflow
  $ 1 -> errorflag

  $ star    -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ lettern -> lstchar ; call writechar
  $ lettera -> lstchar ; call writechar
  $ letterm -> lstchar ; call writechar
  $ lettero -> lstchar ; call writechar
  $ letterf -> lstchar ; call writechar
  $ letterl -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ lettere -> lstchar ; call writechar
  $ letterr -> lstchar ; call writechar
  $ letterr -> lstchar ; call writechar
  $ lettero -> lstchar ; call writechar
  $ letterr -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  call writecrlf
end

# ===== display symbol table data in the listing =====

procedure dumpsym
  call writecrlf
  call writecrlf
  call writecrlf
  call writecrlf
  $ 0 -> i
: dumpsym01
  $ symvalue[i] -> n ; call writehex
  $ space -> lstchar ; call writechar
  $ i -> n ; call writename
  call writecrlf
  $ i + 1 -> i
  $ i < numsym ? dumpsym01
  call writecrlf
  call writecrlf
end

# ===== write a number in decimal format to the listing =====
# ===== value is in n, n is destroyed

procedure writedec
  call int2dec
  $ 9 -> k
  $ 10 -> temp
  $ decarray[temp] = 0 ? writedec01
  $ minus -> lstchar ; call writechar
: writedec01              # skip leading zeros
  $ decarray[k] > 0 ? writedec02
  $ k - 1 -> k
  $ k > 0 ? writedec01    # except the last zero
: writedec02
  $ zerochar + decarray[k] -> lstchar ; call writechar
  $ k - 1 -> k
  $ k > minusone ? writedec02
end

# ===== write a number in hexadecimal format to the listing =====
# ===== value is in n, n is destroyed

procedure writehex
  call int2hex
  $ 7 -> k
: writehex01
  $ hexarray[k] -> temp
  $ hexdigit[temp] -> lstchar ; call writechar
  $ k - 1 -> k
  $ k > minusone ? writehex01
end

# ===== convert to decimal
# ===== value in n, n destroyed
# ===== return value in decarray, array of decimal digit values (not characters!)

procedure int2dec
  $ 10 -> temp $ 0 -> decarray[temp] # sign digit, assume positive
  $ n = minvalue ? int2decminvalue
  $ n > minusone ? int2decnonnegative
  $ 10 -> temp $ 1 -> decarray[temp] # sign digit, now it's negative
  $ 0 - n -> n               # absolute value of negative number
: int2decnonnegative
  $ 0 -> k
: int2dec01
  $ n / 10 -> temp           # shift decimal right
  $ 10 * temp -> temp        # shift decimal left
  $ n - temp -> decarray[k]  # get least significant digit
  $ n / 10 -> n
  $ k + 1 -> k
  $ k < 10 ? int2dec01
  return

  # store -2147483648
: int2decminvalue
  $ 10 -> temp $ 1 -> decarray[temp] # sign digit, minus
  $  9 -> temp $ 2 -> decarray[temp]
  $  8 -> temp $ 1 -> decarray[temp]
  $  7 -> temp $ 4 -> decarray[temp]
  $  6 -> temp $ 7 -> decarray[temp]
  $  5 -> temp $ 4 -> decarray[temp]
  $  4 -> temp $ 8 -> decarray[temp]
  $  3 -> temp $ 3 -> decarray[temp]
  $  2 -> temp $ 6 -> decarray[temp]
  $  1 -> temp $ 4 -> decarray[temp]
  $  0 -> temp $ 8 -> decarray[temp]
end

# ===== convert to hexadecimal
# ===== value in n, n destroyed
# ===== return value in hexarray, array of hexadecimal digit values (not characters!)

procedure int2hex
  $ 0 -> minusflag           # assume positive number
  $ n > minusone ? int2hexnonnegative
  $ 1 -> minusflag
  $ n - minvalue -> n        # strip sign bit
: int2hexnonnegative
  $ 0 -> k
: int2hex01
  $ n / 16 -> temp           # shift hex right
  $ 16 * temp -> temp        # shift hex left
  $ n - temp -> hexarray[k]  # get least significant digit
  $ n / 16 -> n
  $ k + 1 -> k
  $ k < 8 ? int2hex01
  $ minusflag = 0 ? int2hex02
  $ 7 -> temp $ hexarray[temp] + 8 -> hexarray[temp]  # add back sign bit
: int2hex02
end

# ===== write a symbol table name to the listing =====
# ===== name index is in n

procedure writename
  $ symname[n] -> k
: writename01
  $ namepool[k] = 0 ? writename02
  $ namepool[k] -> lstchar ; call writechar
  $ k + 1 -> k
  goto writename01
: writename02
end

# ===== get one source character and send to listing =====

procedure getchar
  call readchar
  $ nxtchar = minusone ? exitgetchar
  $ nxtchar -> lstchar ; call writechar
: exitgetchar
end

# ===== read source character =====
# ===== returns -1 on EOF

procedure readchar
  # read character
  $ srcfile -> sysarg2
  $ 4 -> sysfn
  call system
  $ sysarg1 -> nxtchar
end

# ===== output target byte =====
# in early versions, this is actually a character output

procedure outbyte
  # write character
  $ tgtbyte -> sysarg1
  $ tgtfile -> sysarg2
  $ 5 -> sysfn
  call system
end

procedure outcrlf
  $ cr -> tgtbyte ; call outbyte
  $ lf -> tgtbyte ; call outbyte
end

# ===== output intermediate binary file byte =====

procedure outprebin
  # write byte
  $ tgtbyte -> sysarg1
  $ prebinfile -> sysarg2
  $ 5 -> sysfn
  call system
end

# ===== input intermediate binary file byte =====
# ===== returns -1 on EOF

procedure inprebin
  # read byte
  $ prebinfile -> sysarg2
  $ 4 -> sysfn
  call system
  $ sysarg1 -> tgtbyte
end

# ===== output intermediate table file byte

procedure outtbl
  # write byte
  $ tgtbyte -> sysarg1
  $ tblfile -> sysarg2
  $ 5 -> sysfn
  call system
end

# ===== input intermediate table file byte
# ===== returns -1 on EOF

procedure intbl
  # read byte
  $ tblfile -> sysarg2
  $ 4 -> sysfn
  call system
  $ sysarg1 -> tgtbyte
end

# ===== output final binary file byte =====

procedure outbin
  # write byte
  $ tgtbyte -> sysarg1
  $ binfile -> sysarg2
  $ 5 -> sysfn
  call system
end

# ===== write list character =====

procedure writechar
  # write character
  $ lstchar -> sysarg1
  $ lstfile -> sysarg2
  $ 5 -> sysfn
  call system
end

procedure writecrlf
  $ cr -> lstchar ; call writechar
  $ lf -> lstchar ; call writechar
end

# ===== error routine =====

procedure error
  $ 1 -> errorflag

  $ star    -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ lettere -> lstchar ; call writechar
  $ letterr -> lstchar ; call writechar
  $ letterr -> lstchar ; call writechar
  $ lettero -> lstchar ; call writechar
  $ letterr -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  $ star    -> lstchar ; call writechar
  call writecrlf
end

# ===== write a compilation summary to the list file

procedure writesummary
  call dumpsym

  $ letters -> lstchar ; call writechar
  $ lettery -> lstchar ; call writechar
  $ letterm -> lstchar ; call writechar
  $ letterb -> lstchar ; call writechar
  $ lettero -> lstchar ; call writechar
  $ letterl -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ lettert -> lstchar ; call writechar
  $ lettera -> lstchar ; call writechar
  $ letterb -> lstchar ; call writechar
  $ letterl -> lstchar ; call writechar
  $ lettere -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ lettere -> lstchar ; call writechar
  $ lettern -> lstchar ; call writechar
  $ lettert -> lstchar ; call writechar
  $ letterr -> lstchar ; call writechar
  $ letteri -> lstchar ; call writechar
  $ lettere -> lstchar ; call writechar
  $ letters -> lstchar ; call writechar
  $ colon   -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ numsym -> n ; call writedec
  call writecrlf

  $ lettern -> lstchar ; call writechar
  $ lettera -> lstchar ; call writechar
  $ letterm -> lstchar ; call writechar
  $ lettere -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ letterp -> lstchar ; call writechar
  $ lettero -> lstchar ; call writechar
  $ lettero -> lstchar ; call writechar
  $ letterl -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ letters -> lstchar ; call writechar
  $ letteri -> lstchar ; call writechar
  $ letterz -> lstchar ; call writechar
  $ lettere -> lstchar ; call writechar
  $ colon   -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ space   -> lstchar ; call writechar
  $ namepoolsize -> n ; call writedec
  call writecrlf
end

# ===== parse command line =====
# arguments can always have quotes added,
# so we check for them

declare argtext 4096

procedure parsecommandline
  # get command line
  $ 1 -> sysfn
  call system

  $ 0 -> i
  $ sysarray[i] -> argchar
  $ i + 1 -> i

  # get command
  call getargtext

  # get first arg
  call getargtext

  $ 0 -> k
: copysfnarg
  $ argtext[k] -> temp
  $ temp -> srcfname[k]
  $ k + 1 -> k

  $ temp > 0 ? copysfnarg

  # get second arg
  call getargtext

  $ 0 -> k
: copytfnarg
  $ argtext[k] -> temp
  $ temp -> tgtfname[k]
  $ k + 1 -> k
  $ temp > 0 ? copytfnarg

  # get third arg
  call getargtext

  $ 0 -> k
: copylfnarg
  $ argtext[k] -> temp
  $ temp -> lstfname[k]
  $ k + 1 -> k
  $ temp > 0 ? copylfnarg
end

# =====

procedure getargtext
  $ 0 -> j
: searcharg
  $ argchar = space ? cmdskipspace
  $ argchar = tab ? cmdskipspace
  goto getarg

: cmdskipspace
  $ sysarray[i] -> argchar
  $ i + 1 -> i
  goto searcharg

# ===

: getarg
  $ argchar = quote ? getquotedarg
: getarga
  $ argchar = space ? endarg
  $ argchar = tab ? endarg
  $ argchar = 0 ? endarg

  $ argchar -> argtext[j]
  $ j + 1 -> j
  $ sysarray[i] -> argchar
  $ i + 1 -> i
  goto getarga

# ===

: getquotedarg
  # skip opening quote
  $ sysarray[i] -> argchar
  $ i + 1 -> i
: getquotedarga
  $ argchar = quote ? endquotedarg
  $ argchar = 0 ? endarg

  $ argchar -> argtext[j]
  $ j + 1 -> j
  $ sysarray[i] -> argchar 
  $ i + 1 -> i
  goto getquotedarga

: endquotedarg
  # skip closing quote
  $ sysarray[i] -> argchar 
  $ i + 1 -> i

: endarg
  $ 0 -> argtext[j]
end